%% FILE: alg-csp-cib.tex
%% AUTHORS: Clifford Bergman, William DeMeo
%% DATE: 25 July 2016
%% COPYRIGHT: (C) 2016 Clifford Bergman, William DeMeo,

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                     PREAMBLE                                   %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\documentclass[final]{ws-ijac}
\usepackage{graphicx}
\usepackage{comment}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% showkeys: just comment out in the final version
%\usepackage[notref,notcite]{showkeys}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% \usepackage{setspace}\onehalfspacing

%% removed these for ijac
%% \usepackage{amsmath}
\usepackage{mathtools}

%% \usepackage{bm}
%% \usepackage{latexsym,stmaryrd,mathrsfs,enumerate,scalefnt,ifthen}
\usepackage[mathscr]{euscript}
\usepackage[urlcolor=black,linkcolor=black,citecolor=black]{hyperref}
%% \usepackage{url}
\usepackage{scalefnt}
\usepackage{tikz}
\usepackage{color}

%% \usepackage{cleveref} %[2012/02/15]% v0.18.4; 
% 0.16.1 of May 2010 would be sufficient, but what is the exact day?

\usepackage[multiple]{footmisc}  %% for multiple footnote marks on same text

%% \crefformat{footnote}{#2\footnotemark[#1]#3}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Acronyms
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% \usepackage[acronym, shortcuts]{glossaries}
%\usepackage[smaller]{acro}
\usepackage[smaller]{acronym}
\usepackage{xspace}

%% \acs{CSP} -- short version of the acronym\\
%% \acl{CSP} -- expanded acronym without mentioning the acronym.\\
%% \acp{CSP} -- plurals.\\
%% \acfp{CSP} -- long forms into plurals.\\
%% \acsp{CSP} -- short form into a plural.\\
%% \aclp{CSP} -- long form into a plural.\\
%% \acfi{CSP} -- Full Name acronym in italics and abbreviated form in upshape.\\
%% \acsu{CSP} -- short form of the acronym and marks it as used.\\
%% \aclu{CSP} -- Prints the long form of the acronym and marks it as used.\\


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% \usepackage{inputs/proof-dashed}
\acrodef{lics}[LICS]{Logic in Computer Science}
\acrodef{sat}[SAT]{satisfiability}
\acrodef{nae}[NAE]{not-all-equal}
\acrodef{ctb}[CTB]{cube term blocker}
\acrodef{tct}[TCT]{tame congruence theory}
\acrodef{wnu}[WNU]{weak near-unanimity}
\acrodef{CSP}[CSP]{constraint satisfaction problem}
\acrodef{MAS}[MAS]{minimal absorbing subuniverse}
\acrodef{MA}[MA]{minimal absorbing}
\acrodef{cib}[CIB]{commutative idempotent binar}
\acrodef{sd}[SD]{semidistributive}
\acrodef{NP}[NP]{nondeterministic polynomial time}
\acrodef{P}[P]{polynomial time}
\acrodef{PeqNP}[P $ = $ NP]{P is NP}
\acrodef{PneqNP}[P $ \neq $ NP]{P is not NP}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% MY STUFF
\usepackage{myMacros}
%% END MY STUFF %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% For pseudocode
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}
%% If you are using ubuntu linux and you get the error
%%     LaTeX Error: File `algorithm.sty' not found.
%% then do `sudo apt-get install texlive-science`

%% \linenumbers

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                        FRONT MATTER                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{document}

\markboth{Clifford Bergman and William DeMeo}
{Algebraic Methods for CSP}

%%%%%%%%%%%%%%%%%%%%% Publisher's Area please ignore %%%%%%%%%%%%%%%
%
\catchline{}{}{}{}{}
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\title{UNIVERSAL ALGEBRAIC METHODS FOR\\
CONSTRAINT SATISFACTION PROBLEMS\\
with applications to commutative idempotent binars}
%% \subtitle{with applications to commutative idempotent binars}

%///////////////////////////////////////////////////////////////////////////////////////
%% AUTHORS
\author{CLIFFORD BERGMAN}
\address{Department of Mathematics, Iowa State University\\Ames, IA 50010, USA\\
\email{cbergman@iastate.edu}}

\author{WILLIAM DEMEO}
%% \address{Department of Mathematics, Iowa State University\\Ames, IA 50010, USA\\
\address{Department of Mathematics, University of Hawaii\\Honolulu, Hawaii, 96822 USA\\
%% \address{Department of Mathematics, University of Colorado\\Boulder, CO 80309, USA\\
\email{williamdemeo@gmail.com}}


\maketitle

% ///////////////////////////////////////////////////////////////////////////////////////
%% Date
\begin{history}
\received{(Day Month Year)}
\accepted{(Day Month Year)}
\comby{[editor]}
\end{history}



\begin{abstract}
\input{abstract.tex}
\end{abstract}


%///////////////////////////////////////////////////////////////////////////////////////
%% KEYWORDS
\keywords{%
  constraint satisfaction problem, universal algebra,
  dichotomy conjecture, Mal'tsev condition, Taylor term, absorbing subalgebra.
}


%///////////////////////////////////////////////////////////////////////////////////////
%% AMS SUBJECT CLASSIFICATION
%% see http://www.ams.org/msc Only one Primary. Possibly several Secondary. 
\ccode{Mathematics Subject Classification 2010: 
  08A70 % Applications of universal algebra in computer science
  (%
  68Q15, % Complexity classes (hierarchies, relations among complexity classes, etc.)
  % 68Q17, % Computational difficulty of problems (lower bnds, completeness, etc.)
  03C05, % Equational classes, universal algebra
  % 03D15, % Complexity of computation (including implicit computational complexity)
  % 08A30, % Subalgebras, congruence relations
  08A40) % Operations, polynomials, primal algebras
  %08B05) % Equational logic, Malcev conditions
}

%% \ACMCCS{%
%%   [{\bf Theory of computation}]:
%%   Algebraic complexity theory,
%%   Complexity theory and logic}
  %% [{\bf Computing methodologies}]: Algebraic algorithms}

%% AMS SUBJECT CLASSIFICATION
%% see http://www.ams.org/msc Only one Primary. Possibly several Secondary. 
%% \amsclass{08A70; 03C05, 08A30, 08A40} 



%% \thanks{Research of both authors partially supported by National Science
%%   Foundation grant no.~1500218.}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                           Main Matter                                        %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Section 1
\section{Introduction}
\label{sec:introduction}
\input{introduction.tex}

%% Section 2
\section{Definitions and Notations}
\input{definitions.tex}

%% Section 3
\section{Abelian Algebras}
\input{abelian.tex}

\ifthenelse{\boolean{pagebreaks}}{\newpage}{} %% wjd: pagebreak for ``pagebreaks mode''

%--------------------------------------------------------------------------------
%% Section 4
\section{Absorption Theory}
\label{sec:absorption}
\input{absorption.tex}

%% Section 5
\section{The Rectangularity Theorem}
\label{sec:tayl-vari-rect}
\input{rectangularity.tex}

\ifthenelse{\boolean{pagebreaks}}{\newpage}{} %% wjd: pagebreak for ``pagebreaks mode''

%% Section 6
\section{CSP Applications}
\label{sec:applications}
\input{applications.tex}

\ifthenelse{\boolean{pagebreaks}}{\newpage}{} %% wjd: pagebreak for ``pagebreaks mode''

%% Section 7
\section{Problem Instance Reductions}
\label{sec:var-reduc}
\input{reductions.tex}
 
\ifthenelse{\boolean{pagebreaks}}{\newpage}{} %% wjd: pagebreak for ``pagebreaks mode''

%% Section 8
\section{CSPs of Commutative Idempotent Binars}
\label{sec:csps-comm-idemp}
\input{cibs.tex}

\ifthenelse{\boolean{pagebreaks}}{\newpage}{} 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                           APPENDIX                                           %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section*{Acknowledgments}
Both authors were partially supported
by the National Science Foundation grant no.~1500218.
The second author also gratefully acknowledges support
from the Iowa State University, where the bulk of this research was
conducted, and partial travel support from
the first author's Barbara J.~Janson Professorship.

\appendix

\section{Miscellaneous Proofs}
\label{sec:proofs-elem-facts}
\input{proofs.tex}


\ifthenelse{\boolean{arxiv}}{
  \section{Nonrectangularity of abelian algebras}
  \input{abelian-example.tex}
}{}

\ifthenelse{\boolean{extralong}}{
  \section{Strongly Tractable Divisors}
  \input{tractable-divisors.tex}
}{}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                           BIBLIOGRAPHY                                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\bibliographystyle{ws-ijac} %% or amsalpha
%% \bibliographystyle{plain-url}
%% \bibliographystyle{abbrvnat}
\bibliography{refs}



\end{document}








